Gammal.ib - Feature #1484

Support out-of-source builds
06/28/2015 08:33 PM - Deil Christoph

Status: Closed Start date: 06/28/2015
Priority: Normal Due date:

Assigned To: Knédlseder Jurgen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1.1.0

Description

Looks like Gammalib doesn't support out-of-source builds ... it falls over with the Python extensions:
https://gist.github.com/cdeil/804e727d7b5bd038f8ea

Out-of-source builds are important for developers that want to test multiple compilers / options, or have debug / production builds,
switch between branches ... basically everyone that wants to have more than one build.

Possible?

History

#1 - 06/28/2015 09:09 PM - Knodlseder Jiirgen

What are out of source builds?

#2 - 06/28/2015 09:18 PM - Deil Christoph

An in-source build is if the generated files (object files, library files ... any generated files) are mixed with the source files.
An out-of source build is if the generated files go to a separate folder, leaving the source folder clean.
http://stackoverflow.com/a/1311299/498873

http://www.gnu.org/software/automake/manual/html_node/VPATH-Builds.html
http://voices.canonical.com/jussi.pakkanen/2013/04/16/why-you-should-consider-using-separate-build-directories/

#3 - 07/04/2016 12:10 AM - Knddlseder Jiirgen
- Status changed from New to In Progress
- Assigned To set to Knédlseder Jiirgen

- Target version setto 1.1.0

The following should work:

make distclean
mkdir build

cd build

../configure --srcdir=..
make

For the moment it crashes with:

../../pyext/gammalib/app.i:43: Error: Unable to find 'typemap_GFilename.i'
../../[pyext/gammalib/model.i:43: Error: Unable to find 'typemap_GFilename.i'
../../pyext/gammalib/model.i:46: Error: Unable to find 'GBase.i'
..I..Jpyext/gammalib/model.i:47: Error: Unable to find 'GContainer.i'
../../[pyext/gammalib/model.i:48: Error: Unable to find 'GRegistry.i'
../../pyext/gammalib/model.i:51: Error: Unable to find 'GException.i'

#4 - 07/04/2016 11:02 PM - Knodlseder Jiirgen
- % Done changed from 0 to 50

The following works now:

make distclean

mkdir build

cd build

../configure --srcdir=..
make -j8

make check

however the following still fails:

Jconfigure

make dist

make distcheck

clang -fno-strict-aliasing -fno-common -dynamic -g -O2 -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -I../../../include -I../../../inst/mwl/include
-I../../../inst/cta/include -I../../../inst/lat/include -I../../../inst/com/include -l/usr/local/include -1/usr/local/opt/openssl/include -l/usr/local/opt/sqlite/include
-l/usr/local/Cellar/python/2.7.11/Frameworks/Python.framework/Versions/2.7/include/python2.7 -c gammalib/app_wrap.cpp -0
build/temp.macosx-10.11-x86_64-2.7/gammalib/app_wrap.o

clang: error: no such file or directory: 'gammalib/app_wrap.cpp'

clang: error: no input files

error: command 'clang' failed with exit status 1

and also the following

../configure

make dist

make distcheck

Making all in pyext

/Applications/Xcode.app/Contents/Developer/usr/bin/make all-am

make[4]: *** No rule to make target "../test/test_python.py', needed by “all-am'. Stop.
#5 - 07/04/2016 11:14 PM - Knodlseder Jiirgen
The second problem was solved by adding the .py files to EXTRA_DIST in the test Makefile.am, now we have

../configure

make dist

make distcheck

clang -fno-strict-aliasing -fno-common -dynamic -g -O2 -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -I../../../include -I../../../inst/mwl/include
-l../../../inst/cta/include -I../../../inst/lat/include -1../../../inst/com/include -l/usr/local/include -l/usr/local/opt/openssl/include -l/usr/local/opt/sqlite/include
-l/usr/local/Cellar/python/2.7.11/Frameworks/Python.framework/Versions/2.7/include/python2.7 -c gammalib/app_wrap.cpp -0
build/temp.macosx-10.11-x86_64-2.7/gammalib/app_wrap.o

clang: error: no such file or directory: 'gammalib/app_wrap.cpp'

clang: error: no input files

error: command 'clang' failed with exit status 1

so the same error is for the build in the source directory.

#6 - 07/07/2016 03:49 PM - Knodlseder Jiirgen
- % Done changed from 50 to 80

This now works for Gammalib. Merged into devel. Still need to make sure that ctools also supports out of source builds.
#7 - 07/11/2016 12:45 PM - Knodlseder Jiirgen
- Status changed from In Progress to Closed

- % Done changed from 80 to 100

This now also works for ctools.
